import com.sun.java.swing.JOptionPane;
import com.sun.java.swing.JDialog;
import com.sun.java.swing.JTextField;
import com.sun.java.swing.JPasswordField;

import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;

class LoginDialog extends JDialog {
    private String aDBSite = null;
    private String anID = null;
    private String aPassword = null;

    private JOptionPane optionPane;

    public String[] getValidatedText() {
        String[] location = {aDBSite, anID, aPassword};
        return location;
    }

    public LoginDialog(menu_swing aFrame) {
        super(aFrame, true);
        //final DialogDemo dd = parent;

        setTitle("Login to Database");

        final String msgString1 = "Please Enter DBsite";
        final JTextField textField = new JTextField(10);
        final String msgString2 = "User ID";
        final JTextField IDField = new JTextField(10);
        final String msgString3 = "and Password.";
        final JPasswordField passwdField = new JPasswordField(10);

        Object[] array = {msgString1, textField, msgString2, IDField,
                                             msgString3, passwdField};

        final String btnString1 = "Enter";
        final String btnString2 = "Cancel";
        Object[] options = {btnString1, btnString2};

        optionPane = new JOptionPane(array, 
                                    JOptionPane.QUESTION_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options,
                                    options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                /*
                 * Instead of directly closing the window,
                 * we're going to change the JOptionPane's
                 * value property.
                 */
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        textField.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                optionPane.setValue(btnString1);
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible() 
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        //ignore reset
                        return;
                    }

                    if (value.equals(btnString1)) {
                        aDBSite = textField.getText();
                        anID = IDField.getText();
                        aPassword = passwdField.getText();
                        System.out.println("Site: " + aDBSite + " ID: " + anID
                                           + " Password: " + aPassword);
                        setVisible(false);
                    } else { // user closed dialog or clicked cancel
                        System.out.println("Login is canceled.");
                        setVisible(false);
                    }
                }
            }
        });
    }
}

